scaling

Post here for help on using FreeCAD's graphical user interface (GUI).
Forum rules
and Helpful information
IMPORTANT: Please click here and read this first, before asking for help

Also, be nice to others! Read the FreeCAD code of conduct!
drmacro
Veteran
Posts: 8984
Joined: Sun Mar 02, 2014 4:35 pm

Re: scaling

Post by drmacro »

degarb wrote: Wed Apr 21, 2021 7:13 pm https://photos.app.goo.gl/a1DnWfkLGioKTnHE7

It spits out error on trying to clone or scale this simple arc. This is not consistent with the docs, nor video tutorials.

I am not doing anything wrong. It has to be some toolbar item , or pref.
I open Draft workbench, create an arc. Click scale and proceed, no errors...
Attachments
Snip macro screenshot-d1f2b2.png
Snip macro screenshot-d1f2b2.png (91.44 KiB) Viewed 691 times
Star Trek II: The Wrath of Khan: Spock: "...His pattern indicates two-dimensional thinking."
degarb
Posts: 58
Joined: Fri Apr 16, 2021 7:49 pm

Re: scaling

Post by degarb »

That is because you are not doing it right. carefully measure and make about 1879 or more arcs and circles. Then try to bulk clone, scaled and remove dependencies.

YOu find it will be easier to measure and redraw the entire 1900 objects than to edit each 3000 scales of x y and z, because it refuses to scale a clone. If you manage to get a scaled clone, copy and delete the original, you will find the drawing unchangeable as new protype adjustments are needed .

I am sorry, but I ran into about 13 bugs this night in the program.

I have been trying for 2 days to scale. I don't know how to program a command line for all 1879 objects. My drawing is perfect after a week, for now, I just cannot stretch or scale jack. version 1.7 scales a little better, but it is leaving out half of the drawing. There has much to be done with scale. version 1.9 degrades the limited ability of 1.7 to scale, which is basically mostly broken. Everyone is trying to scale one object. I am trying to bulk scale many.

I also am on windows 10, quite frankly, I can do 60x more on windows than linux. I hate repositories and every under the hood of linux. I realize many are probaly using linux. But linux is not for me, windows is much more powerful. Linux doesn't even have macro ability to string together many programs . Everything is also 20 times more time consuming in linux, and more constrained. Their community was a bunch of idiots for many years, before ubuntu.
User avatar
Roy_043
Veteran
Posts: 8552
Joined: Thu Dec 27, 2018 12:28 pm

Re: scaling

Post by Roy_043 »

drmacro wrote: Wed Apr 21, 2021 7:28 pm I open Draft workbench, create an arc. Click scale and proceed, no errors...
You are scaling a clone.
If I follow your procedure I get the following error message:
Unable to scale object: Arc - This object type cannot be scaled directly. Please use the clone method.

Are you saying that a clone is created automatically for you?

Code: Select all

OS: Windows 8.1 Version 6.3 (Build 9600)
Word size of FreeCAD: 64-bit
Version: 0.20.24587 (Git)
Build type: Release
Branch: master
Hash: 1f62d4666102d8efd4d8f3ba58a1037456a3bcfb
Python version: 3.8.6+
Qt version: 5.15.1
Coin version: 4.0.1
OCC version: 7.5.0
Locale: Dutch/Netherlands (nl_NL)
Bance
Veteran
Posts: 4255
Joined: Wed Feb 11, 2015 3:00 pm
Location: London

Re: scaling

Post by Bance »

I'm sorry for your frustration, but it really looks like it is self inflicted.

Everybody else is succeeding in an operation that fails for you, but they're not doing it right!

Carefully measure and model , why then are they scaled?

13 bugs ? Please describe them so they can be fixed.

As to the rant about Linux, well that's just TROLLING.
mario52
Veteran
Posts: 4692
Joined: Wed May 16, 2012 2:13 pm

Re: scaling

Post by mario52 »

hi

tray Macro_CloneConvert Image (create clone or independent copy)

mario
Maybe you need a special feature, go into Macros_recipes and Code_snippets, Topological_data_scripting.
My macros on Gist.github here complete macros Wiki and forum.
drmacro
Veteran
Posts: 8984
Joined: Sun Mar 02, 2014 4:35 pm

Re: scaling

Post by drmacro »

degarb wrote: Thu Apr 22, 2021 1:46 am That is because you are not doing it right. carefully measure and make about 1879 or more arcs and circles. Then try to bulk clone, scaled and remove dependencies.
One of us is, indeed, doing it wrong... :mrgreen:
Star Trek II: The Wrath of Khan: Spock: "...His pattern indicates two-dimensional thinking."
heda
Veteran
Posts: 1348
Joined: Sat Dec 12, 2015 5:49 pm

Re: scaling

Post by heda »

when working with fc one needs a growth mindset, as opposed to fixed.
if the term is unknown, search the web for explanation.


any ways, also I think that the scale in draft is somewhat broken.
why is it possible to get the preview of scaled arcs but it will not do it for real?
I guess there is a underlying technical reason, but not sure what that would be,
considering that the preview makes it...

attaching a small file showing how it behaves.

sure, in this case life becomes easier if one uses a bit of coding,
for example writing ones own function for scaling arcs,
but it would be nice if it worked out of the box.

another way to make life easier is of course to use the sketcher.

what is not clear to me in this endeavour is why the scaling is needed to begin with.
generally things are drawn to size and then presenting might be in scale...
Attachments
scale.FCStd
(69.68 KiB) Downloaded 27 times
mario52
Veteran
Posts: 4692
Joined: Wed May 16, 2012 2:13 pm

Re: scaling

Post by mario52 »

Hi
heda wrote: Thu Apr 22, 2021 4:31 pm I think that the scale in draft is somewhat broken.
with Draft : (select the object)

Code: Select all

import Draft, Part
selobject = FreeCADGui.Selection.getSelection()
uniteScale_X = uniteScale_Y = uniteScale_Z = 2.0
#
tampon = Draft.scale(selobject,App.Vector(uniteScale_X, uniteScale_Y, uniteScale_Z),center=App.Vector(0,0,0),copy=False) # if copy is True: the original object stay
#
print(tampon.Name)

with Part and Draft: (select the object)

Code: Select all

import Draft, Part
selobject = FreeCADGui.Selection.getSelection()
uniteScale_X = uniteScale_Y = uniteScale_Z = 2.0
#
Part.show(Draft.scale(selobject,App.Vector(uniteScale_X, uniteScale_Y, uniteScale_Z),center=App.Vector(0,0,0),copy=False).Shape)# if copy is True: duplique l'original
#
tampon = App.ActiveDocument.ActiveObject
print(tampon.Name)
mario
Maybe you need a special feature, go into Macros_recipes and Code_snippets, Topological_data_scripting.
My macros on Gist.github here complete macros Wiki and forum.
heda
Veteran
Posts: 1348
Joined: Sat Dec 12, 2015 5:49 pm

Re: scaling

Post by heda »

oki,

would still argue broken from user perspective.

the draft sample code does not seem so scale an arc, it does put it on the screen, it makes a new one with copy=True,
but upon recompute, it assumes same dimensions as original arc.

the part version does make new geometry that sticks.
so something like this would chew a box selection

Code: Select all

import Draft, Part
selobject = FreeCADGui.Selection.getSelection()
uniteScale_X = uniteScale_Y = uniteScale_Z = 2.0
#
for obj in selobject:
    Part.show(Draft.scale(obj, App.Vector(uniteScale_X, uniteScale_Y, uniteScale_Z),
                          center=App.Vector(0,0,0),copy=False).Shape)
disclaimer - with copy=False it actually flips so that the line now is the scaled line and the shape is where the original line was,
copy=True does not really make it better with a lot of unneeded geometry.


looking into the shapes, the lines downgrade/upgrade to normal lines,
the shapes from arcs are not possible to upgrade/downgrade to something else.
but they convert to a sketch, and then they become bsplines,
which I suppose is the underlying technical reason for arcs being troublesome to scale,
they are no longer arcs if the scaling is not uniform,
however when the scaling is uniform, that could be handled as just scaling the arc as one would expect the program to do

so suppose that one with a lot of hoops and loops can roll ones own uniform scale function to scale arcs...
degarb
Posts: 58
Joined: Fri Apr 16, 2021 7:49 pm

Re: scaling

Post by degarb »

heda wrote: Thu Apr 22, 2021 4:31 pm when working with fc one needs a growth mindset, as opposed to fixed.
if the term is unknown, search the web for explanation.


any ways, also I think that the scale in draft is somewhat broken.
why is it possible to get the preview of scaled arcs but it will not do it for real?
I guess there is a underlying technical reason, but not sure what that would be,
considering that the preview makes it...

attaching a small file showing how it behaves.

sure, in this case life becomes easier if one uses a bit of coding,
for example writing ones own function for scaling arcs,
but it would be nice if it worked out of the box.

another way to make life easier is of course to use the sketcher.

what is not clear to me in this endeavour is why the scaling is needed to begin with.
generally things are drawn to size and then presenting might be in scale...

Thanks, heda. I agree.

I spent 2 days trying to scale all of my drawings in draft. I can't get a handle on part design or sketcher. Draft makes logical sense. I tried the other workbenchs, the ones that don't give me alerts i don't understand like part design where I cant get past a line parameter dialog to even use. "what is the line parameters dialog in part design? freecad how do I get rid of it?" I started to write down all the apparent bugs and my workarounds. The clone method didn't scale arcs any better, no matter what I clicked and any combination. I carefully tried every single dialog combinations possible. I then tried 1.7, which actually partially scaled some of the objects using a clone method. I realized that I might have had partial luck before scaling by exporting to dxf, then importing, changing everything to 2d shape. However I decided not to worry about clearing every dependancy. So, spent until 3am redrawing everything to the desired scale. I had to debug things for a few hours today. I declared draft scaling dead to me and broken. I tried everything. Make no mistake it works better, a little better in 1.7 than 1.9.

At any rate. I think I mastered draft well enough, and got my dxf. Drum roll, if the laser burning guys can read it without complaints.

I think I am going to need to 3d model the finished unit, because my artist is not able to get proper perspective.

I watched basic tutorials, and read. I opened wb part design. Opened a body, created a sketch, but cant draw on it because of a parameter dialiog where nothing seem to be documented or is able to dismiss or click anything.
Post Reply